<script setup lang="ts">
import AutoComplete, {type AutoCompleteCompleteEvent} from "primevue/autocomplete";
import {ref} from "vue";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import {useSnackbarStore} from "@/stores/Snackbar/SnackbarStore";
import type Repository from "@/entities/Repository/Repository";

const props = defineProps<{
  repository: Repository,
  required: Boolean
}>()

const snackbarStore = useSnackbarStore();
const branch = defineModel('branch')

const repositoryApiHandler = new RepositoryApiHandler();
const branches = ref([]);

const searchBranch = (event: AutoCompleteCompleteEvent) => {
  const search = event.query;
  repositoryApiHandler.searchBranches(props.repository, search)
      .then(branchesList => branches.value = branchesList.map((branch: object) => branch.title))
      .catch(snackbarStore.createMessagesFromError);
}

</script>

<template>
  <AutoComplete
      v-model="branch"
      :suggestions="branches"
      @complete="searchBranch"
      dropdown
      placeholder="Recherchez une branche"
      minlength="3"
      maxlength="20"
      inputClass="w-full"
      :invalid="required && !branch"
      :inputProps="{required: required, autofocus: true}"
  />
</template>